%define anolis_release 1
%global toolchain clang
%global libcxxabi_version 13.0.1
%global libcxxabi_srcdir libcxxabi-%{libcxxabi_version}%{?rc_ver:rc%{rc_ver}}.src


Name:		libcxxabi
Version:	%{libcxxabi_version}%{?rc_ver:~rc%{rc_ver}}
Release:	%{anolis_release}%{?dist}
Summary:	Low level support for a standard C++ library
License:	MIT or NCSA
URL:		http://libcxxabi.llvm.org/
Source0:	https://github.com/llvm/llvm-project/releases/download/llvmorg-%{libcxxabi_version}%{?rc_ver:-rc%{rc_ver}}/%{libcxxabi_srcdir}.tar.xz
Source1:	https://github.com/llvm/llvm-project/releases/download/llvmorg-%{libcxxabi_version}%{?rc_ver:-rc%{rc_ver}}/%{libcxxabi_srcdir}.tar.xz.sig
Source2:	tstellar-gpg-key.asc

Patch0:		0001-PATCH-libcxxabi-Include-refstring.h-from-system-incl.patch
Patch1:		0002-PATCH-libcxxabi-Remove-monorepo-requirement.patch

BuildRequires:	clang llvm-devel cmake llvm-static ninja-build
BuildRequires:	libcxx-devel >= %{version}

# For origin certification
BuildRequires:	gnupg2

%description
libcxxabi provides low level support for a standard C++ library.

%package devel
Summary:	Headers and libraries for libcxxabi devel
Requires:	%{name} = %{version}-%{release}

%description devel
%{summary}.

%package static
Summary:	Static libraries for libcxxabi

%description static
%{summary}.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%{gpgverify} --keyring='%{SOURCE2}' --signature='%{SOURCE1}' --data='%{SOURCE0}'
%autosetup -n %{libcxxabi_srcdir} -p2

sed -i 's|${LLVM_BINARY_DIR}/share/llvm/cmake|%{_libdir}/cmake/llvm|g' CMakeLists.txt

%build
%cmake  -GNinja \
	-DCMAKE_C_COMPILER=/usr/bin/clang \
	-DCMAKE_CXX_COMPILER=/usr/bin/clang++ \
	-DLLVM_CONFIG_PATH=%{_bindir}/llvm-config \
	-DCMAKE_CXX_FLAGS="-std=c++11" \
	-DLIBCXXABI_LIBCXX_INCLUDES=%{_includedir}/c++/v1/ \
	-DLIBCXXABI_LIBDIR_SUFFIX:STRING=64 \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo


%cmake_build

%install
%cmake_install

mkdir -p %{buildroot}%{_includedir}
cp -a include/* %{buildroot}%{_includedir}

%ldconfig_scriptlets

%files
%license LICENSE.TXT
%{_libdir}/libc++abi.so.*

%files devel
%{_includedir}/*.h
%{_libdir}/libc++abi.so

%files static
%{_libdir}/libc++abi.a

%files doc
%doc CREDITS.TXT

%changelog
* Thu Aug 18 2022 happy_orange <songnannan@linux.alibaba.com> - 13.0.1-1
- Init package from upstream
